function [xvals, U] = godunov(N, T)

    f = @(x) (2/3)*x.^(3/2);
    df = @(x) sqrt(x);

    xvals = linspace(-1, 4, N+2);
    h = xvals(2) + 1;
    Niters1 = round(T/h);

    u = (xvals>=0).*(xvals<=1).*(sin(pi*xvals)).^2;

    i = 1;
    while (true)
        u = u + f(uarrow([0,u(1:end-1)],u)) - f(uarrow(u,[u(2:end),0]));
        if i == Niters1, U = u; break; end;
        i = i+1;
    end;

    function out = uarrow(v,w)
        sdot = (f(w)-f(v))./(w-v);
        out = v .* ((v<=w) | ((v>w)&(sdot>0))) + w .* ((v>w)&(sdot<0));
    end

end
