function ufinal = solveCP(a, b, N, u0, T)

    h = (b-a)/N;
    K = max(abs(sinh(u0)));
    taumax = h/K;
    timesteps = ceil(T/taumax);
    tau = T/timesteps;

    ufinal = u0;

    for i = 1:timesteps

        uplus = [ufinal(2:end), ufinal(end)];
        uminus = [ufinal(1), ufinal(1:end-1)];

        ufinal = ufinal - (tau/h)*(eonf(ufinal, uplus) - eonf(uminus, ufinal));

    end

end
