u0 = @(x) double(x>=0);
uex = @(x) log((x<=1) + (x>=exp(1)) + (x>1).*(x<exp(1)).*x) + (x>=exp(1));

Mvals = [20, 40, 80, 160, 320, 640];
errs = zeros(size(Mvals));

for i = 1:length(Mvals)
    u = lwsol(u0, 1, Mvals(i));
    h = exp(1)/Mvals(i);
    xvals = (floor(-3/h):ceil((3+1)/h))*h;

    errs(i) = h*sum(abs(u-uex(xvals)));
end

loglog(Mvals, errs, '+-');
grid('on');
xlabel('M');
ylabel('err(M)');

p = polyfit(log(Mvals), log(errs), 1);
-p(1)
