function muend = godsol_LW(u0,T,M)

    % Steps
    tau = T/M;
    h = exp(1)*tau;
    gamma = exp(-1);                                % tau/h
    jvals = floor(-3*T/h):ceil((1+3*T)/h);
    xvals = jvals*h;

    % Initial condition
    mu = u0(xvals);

    % Loop
    for i = 1:M
        mu_p = mu(3:end);
        mu_m = mu(1:end-2);

        mu_n = mu;
        mu = mu(2:end-1);
        mu_n(2:end-1) = mu + gamma*(godunov(mu_m,mu) - godunov(mu,mu_p));

        mu = mu_n;
    end

    muend = mu;

    function out = godunov(v,w)

        out = exp(v);

    end

end
