function muend = lwsol(u0,T,M)

    % Steps
    tau = T/M;
    h = exp(1)*tau;
    gamma = exp(-1);                                % tau/h
    jvals = floor(-3*T/h):ceil((1+3*T)/h);
    xvals = jvals*h;

    % Initial condition
    mu = u0(xvals);

    % Loop
    for i = 1:M
        mu_p = mu(3:end);
        mu_m = mu(1:end-2);

        mu_n = mu;
        mu = mu(2:end-1);
        mu_n(2:end-1) =  mu - 0.5*gamma*(exp(mu_p)-exp(mu_m))... 
            + 0.5*gamma^2*(exp(mu_p+mu).*(mu_p-mu) - exp(mu+mu_m).*(mu-mu_m));

        mu = mu_n;
    end

    muend = mu;

end
