function gvec = G(muvec, f, F, Ml, Mr, h)

    N = 2*(Ml+Mr+1);
    M = N/2;

    % Reshape to Mx2 matrices
    muvec = reshape(muvec, 2, M);
    gvec = zeros(2, M);

    % uN evaluated at gridpoints (note the boundary zeros)
    uNminus = [0, muvec(1,:) + h/2 * muvec(2,:)];
    uNplus = [muvec(1,:) - h/2 * muvec(2,:), 0];

    % Numerical flux
    nFlux = arrayfun(F, uNminus, uNplus);
    gvec(1,:) = nFlux(2:end) - nFlux(1:end-1);
    gvec(2,:) = h/2 * (nFlux(2:end) + nFlux(1:end-1));

    % Integral term
    a = h/2/sqrt(3);
    gvec(2,:) = gvec(2,:) - h/2 * (arrayfun(f, muvec(1,:)-a*muvec(2,:)) + arrayfun(f, muvec(1,:)+a*muvec(2,:)));

    % Reshape to Nx1 vector
    gvec = reshape(gvec, N, 1);

end
