% Basic parameters
h = 0.05;
T = 1;
m = ceil(T/(h/3));
Mr = ceil(2/h);
Ml = ceil(2/h) - 1;
f = @(u) u*(1-u);

% Initial condition
mu0 = zeros(2,Mr+Ml+1);
mu0(1, Ml+2:Ml+1+Mr/2) = 1;
mu0 = mu0(:);

mufinal = dgcl(mu0, f, @Feo, T, Ml, Mr, h, m);

mufinal = reshape(mufinal, 2, Ml+Mr+1);
plot(linspace(-2,2,Ml+Mr+1), mufinal(1,:), 'LineWidth', 2);
xlabel('x'); ylabel('t');
axis([-2 2 -0.1 1.1]);
